From 57d81a12fb3e792be0fd1251868ce9676102b1aa Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 01 2020 17:13:24 +0000
Subject: [PATCH 511/2232] Merge pull request #180 from jgalenson/enums


Properly handle enum discriminant overflows.
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 2e1873c..a3c8d1a 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -127,14 +127,19 @@ fn expand_struct(strct: &Struct) -> TokenStream {
 fn expand_enum(enm: &Enum) -> TokenStream {
     let ident = &enm.ident;
     let doc = &enm.doc;
-    let variants = enm.variants.iter().scan(0, |next_discriminant, variant| {
-        let variant_ident = &variant.ident;
-        let discriminant = variant.discriminant.unwrap_or(*next_discriminant);
-        *next_discriminant = discriminant + 1;
-        Some(quote! {
-            pub const #variant_ident: Self = #ident(#discriminant);
-        })
-    });
+    let variants = enm
+        .variants
+        .iter()
+        .scan(None, |prev_discriminant, variant| {
+            let variant_ident = &variant.ident;
+            let discriminant = variant
+                .discriminant
+                .unwrap_or_else(|| prev_discriminant.map_or(0, |n| n + 1));
+            *prev_discriminant = Some(discriminant);
+            Some(quote! {
+                pub const #variant_ident: Self = #ident(#discriminant);
+            })
+        });
     quote! {
         #doc
         #[derive(Copy, Clone, PartialEq, Eq)]
diff --git a/syntax/check.rs b/syntax/check.rs
index a99e982..06bf65b 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -204,14 +204,23 @@ fn check_api_enum(cx: &mut Check, enm: &Enum) {
     }
 
     let mut discriminants = HashSet::new();
-    enm.variants.iter().fold(0, |next_discriminant, variant| {
-        let discriminant = variant.discriminant.unwrap_or(next_discriminant);
-        if !discriminants.insert(discriminant) {
-            let msg = format!("discriminant value `{}` already exists", discriminant);
-            cx.error(span_for_enum_error(enm), msg);
-        }
-        discriminant + 1
-    });
+    enm.variants
+        .iter()
+        .fold(None, |prev_discriminant, variant| {
+            if variant.discriminant.is_none() && prev_discriminant.unwrap_or(0) == u32::MAX {
+                let msg = format!("overflowed on value after {}", prev_discriminant.unwrap());
+                cx.error(span_for_enum_error(enm), msg);
+                return None;
+            }
+            let discriminant = variant
+                .discriminant
+                .unwrap_or_else(|| prev_discriminant.map_or(0, |n| n + 1));
+            if !discriminants.insert(discriminant) {
+                let msg = format!("discriminant value `{}` already exists", discriminant);
+                cx.error(span_for_enum_error(enm), msg);
+            }
+            Some(discriminant)
+        });
 }
 
 fn check_api_type(cx: &mut Check, ty: &ExternType) {
diff --git a/tests/ui/enum_overflows.rs b/tests/ui/enum_overflows.rs
new file mode 100644
index 0000000..3f351f0
--- /dev/null
+++ b/tests/ui/enum_overflows.rs
@@ -0,0 +1,17 @@
+#[cxx::bridge]
+mod ffi {
+    enum Good1 {
+        A = 0xffffffff,
+    }
+    enum Good2 {
+        B = 0xffffffff,
+        C = 2020,
+    }
+    enum Bad {
+        D = 0xfffffffe,
+        E,
+        F,
+    }
+}
+
+fn main() {}
diff --git a/tests/ui/enum_overflows.stderr b/tests/ui/enum_overflows.stderr
new file mode 100644
index 0000000..3d1b370
--- /dev/null
+++ b/tests/ui/enum_overflows.stderr
@@ -0,0 +1,9 @@
+error: overflowed on value after 4294967295
+  --> $DIR/enum_overflows.rs:10:5
+   |
+10 | /     enum Bad {
+11 | |         D = 0xfffffffe,
+12 | |         E,
+13 | |         F,
+14 | |     }
+   | |_____^

